|
| chkstk.a86
|      Check stack (probe) and allocate stack variables
|
| Called at entry to EACH C-procedure to do a well-defined sequence of
| code to allocate local-variables on the stack.  In addition, the stack
| is probed to insure the space is allocated.  The kernel can sense this
| sequence of instructions, during a trap.
|
| This procedure will be replaced by an in-line stack-probe of the form:
|
|      push    bp
|      mov     bp, sp
|      mov     ax, -size(bp)           | probe!
|      push    di
|      push    si
|
| On entry, AX = amount to adjust the stack.
|
| Bob Beck, 3-3-82.
|
|
| PROBESLOP defines enough room to insure there is enough room for various
| system needs: sys-call, IO-int, etc.  Also, insures room for C-expression
| evaluation temporaries, and nested procedure call.


PROBESLOP =	256

	.text				|
	.globl	chkstk			| they need this!
chkstk:					|
	mov	bx, sp			|
	sub	bx, ax			| BX -> lowest new stack address
	cmp     bx,Stkbot
	jb      chkst2                  | need to grow
chkst1: pop     chkret                  | (chkret) = return address
	pop	chkret+2
	mov	sp, bx			| set stack
	jmpi    @chkret                 | return

chkst2: push    bx                      | save bx
	sub     bx,#PROBESLOP
	calli   @Isgadr                 | call routine to remap I-space
	add     ax,#PROBESLOP/2
	mov     Stkbot,ax
	pop     bx                      | (bx) = saved request
	j       chkst1


	.data
Stkbot: .word   -1                      | stack bottom limit
chkret:	.word	0			| return address
	.word	0



.end
