/*      getlogin - get login name
 *
 *      Note that its possible that the originator of this job as
 *      logged out, and someone else has logged in.  We'll see that
 *      new name!
 */

/*      Modification history
 *
 *  JGL 03/13/82        M001
 *      if person has logged out, return a null pointer, not a pointer
 *      to a null string
 */


#include <utmp.h>

static	char	UTMP[]	= "/etc/utmp";
static	struct	utmp ubuf;

char *
getlogin()
{
	register me, uf;
	register char *cp;

	if( !(me = ttyslot()) )
		return(0);
	if( (uf = open( UTMP, 0 )) < 0 )
		return(0);
	lseek( uf, (long)(me*sizeof(ubuf)), 0 );
	if (read(uf, (char *)&ubuf, sizeof(ubuf)) != sizeof(ubuf))
		return(0);
	close(uf);
	ubuf.ut_name[8] = ' ';
	for (cp=ubuf.ut_name; *cp++!=' ';)
		;
	*--cp = '\0';
	if (ubuf.ut_name[0])                            /* M001 */
		return( ubuf.ut_name );                 /* M001 */
	else                                            /* M001 */
		return(0);                              /* M001 */
}
